map1 = {}

function map1.load()
	map1.setup()
	map1.create()
end

function map1.setup()
	if love.filesystem.exists("maps/demo.tmx") then
		local linen = 0
		for line in love.filesystem.lines("maps/demo.tmx") do
			linen = linen + 1
			if linen == 2 then
				iter = string.gmatch(line, "%P+")
				for i = 1,6 do
					iter()
				end
				map1.width = tonumber(iter())
				print(map1.width)
				iter()
				map1.height = tonumber(iter())
				print(map1.height)
				iter()
				map1.tileWidth = tonumber(iter())
				print(map1.tileWidth)
				iter()
				map1.tileHeight = tonumber(iter())
				print(map1.tileHeight)
			end
			if linen == 3 then
				iter = string.gmatch(line, "%P+")
				for i = 1,2 do
					iter()
				end
				map1.tileset1FirstGid = tonumber(iter())
				print(map1.tileset1FirstGid)
				iter()
				map1.tileset1Name = iter()
				print(map1.tileset1Name)
				iter()
				map1.tileset1TileWidth = tonumber(iter())
				print(map1.tileset1TileWidth)
				iter()
				map1.tileset1TileHeight = tonumber(iter())
				print(map1.tileset1TileHeight)
				iter()
			end
			if linen == 4 then
				iter = string.gmatch(line, "%P+")
				for i = 1,2 do
					iter()
				end
				map1.tileset1ImageSource = iter() .. "/" .. iter() .. ".png"
				print(map1.tileset1ImageSource)
				iter()
				iter()
				map1.tileset1Width = tonumber(iter())
				print(map1.tileset1Width)
				iter()
				map1.tileset1Height = tonumber(iter())
				print(map1.tileset1Height)
			end
			if linen == 6 then
				iter = string.gmatch(line, "%P+")
				for i = 1,2 do
					iter()
				end
				map1.tileset2FirstGid = tonumber(iter())
				print(map1.tileset2FirstGid)
				iter()
				map1.tileset2Name = iter()
				print(map1.tileset2Name)
				iter()
				map1.tileset2TileWidth = tonumber(iter())
				print(map1.tileset2TileWidth)
				iter()
				map1.tileset2TileHeight = tonumber(iter())
				print(map1.tileset2TileHeight)
				iter()
			end
			if linen == 7 then
				iter = string.gmatch(line, "%P+")
				for i = 1,2 do
					iter()
				end
				map1.tileset2ImageSource = iter() .. "/" .. iter() .. ".png"
				print(map1.tileset2ImageSource)
				iter()
				iter()
				map1.tileset2Width = tonumber(iter())
				print(map1.tileset2Width)
				iter()
				map1.tileset2Height = tonumber(iter())
				print(map1.tileset2Height)
			end
			if linen == 9 then
				iter = string.gmatch(line, "%P+")
				for i = 1,2 do
					iter()
				end
				map1.layer1 = iter()
				print(map1.layer1)
				iter()
				map1.layer1Width = tonumber(iter())
				print(map1.layer1Width)
				iter()
				map1.layer1Height = tonumber(iter())
				print(map1.layer1Height)
			end
			if line == "  <data>" then
				Data = true
				if data then
					data = data + 1
				else
					data = 1
				end
			end
			if Data == true then
				if data == 1 then
					if tilen then
						tilen = tilen + 1
					else
						tilen = 1
					end
					if map1.layer1TileRaw then
					
					else
						map1.layer1TileRaw = {}
					end
					if line ~= "  </data>" then
						map1.layer1TileRaw[tilen - 1] = line
						--print(map1.layer1Tile[tilen])
					end
				end
				if data == 2 then
					if tilen then
						tilen = tilen + 1
					else
						tilen = 1
					end
					if map1.layer2TileRaw then
					
					else
						map1.layer2TileRaw = {}
					end
					if line ~= "  </data>" then
						map1.layer2TileRaw[tilen - 1] = line
						--print(map1.layer2Tile[tilen])
					end
				end
				if line == "  </data>" then
					Data = false
					tilen = 0
				end
			end
			if line == " </layer>" and data == 1 then
				layer1EndLine = linen
			end
			if layer1EndLine then
				if linen == layer1EndLine + 1 then
					iter = string.gmatch(line, "%P+")
					for i = 1,2 do
						iter()
					end
					map1.layer2 = iter()
					print(map1.layer2)
					iter()
					map1.layer2Width = tonumber(iter())
					print(map1.layer2Width)
					iter()
					map1.layer2Height = tonumber(iter())
					print(map1.layer2Height)
				end
			end
		end
	end
end

function map1.create()
	map1.layer1Tile = {}
	for i=1,  map1.layer1Width * map1.layer1Height do
		iter = string.gmatch(map1.layer1TileRaw[i], "%P+")
		iter()
		iter()
		map1.layer1Tile[i] = iter()
	end
	map1.layer2Tile = {}
	for i=1,  map1.layer2Width * map1.layer2Height do
		iter = string.gmatch(map1.layer2TileRaw[i], "%P+")
		iter()
		iter()
		map1.layer2Tile[i] = iter()
	end
	
	map1.tileset = {}
	map1.tileset2 = {}
	map1.tileset2Image = love.graphics.newImage(map1.tileset2ImageSource)
	for i =1, (map1.tileset2Width / map1.tileset2TileWidth) * (map1.tileset2Height / map1.tileset2TileHeight) do
		map1.tileset[i + map1.tileset2FirstGid - 1] = love.graphics.newQuad(((i-1)%map1.tileset2Width)*map1.tileset2TileWidth, math.floor((i)/map1.tileset2Width)*map1.tileset2TileHeight, map1.tileset2TileWidth, map1.tileset2TileHeight, map1.tileset2Width, map1.tileset2Height)
	end
	
	map1.tileset1 = {}
	map1.tileset1Image = love.graphics.newImage(map1.tileset1ImageSource)
	for i =1, (map1.tileset1Width / map1.tileset1TileWidth) * (map1.tileset1Height / map1.tileset1TileHeight) do
		map1.tileset[i + map1.tileset1FirstGid - 1] = love.graphics.newQuad(((i-1)%map1.tileset1Width)*map1.tileset1TileWidth, math.floor((i)/map1.tileset1Width)*map1.tileset1TileHeight, map1.tileset1TileWidth, map1.tileset1TileHeight, map1.tileset1Width, map1.tileset1Height)
	end
end

function map1.draw()
	for i=1, map1.layer1Width * map1.layer1Height do
		if tonumber(map1.layer1Tile[i]) >= map1.tileset1FirstGid then
			if tonumber(map1.layer1Tile[i]) < map1.tileset2FirstGid then
				love.graphics.draw(map1.tileset1Image, map1.tileset[tonumber(map1.layer1Tile[i])], ((i-1)%map1.layer1Width)*map1.tileset1TileWidth, math.floor((i)/map1.layer1Width)*map1.tileset1TileHeight)
			elseif tonumber(map1.layer1Tile[i]) >= map1.tileset2FirstGid then
				love.graphics.draw(map1.tileset2Image, map1.tileset[tonumber(map1.layer1Tile[i])], ((i-1)%map1.layer1Width)*map1.tileset2TileWidth, math.floor((i)/map1.layer1Width)*map1.tileset2TileHeight)
			end
		end
	end
	for i=1, map1.layer2Width * map1.layer2Height do
		if tonumber(map1.layer2Tile[i]) >= map1.tileset1FirstGid then
			if tonumber(map1.layer2Tile[i]) < map1.tileset2FirstGid then
				love.graphics.draw(map1.tileset1Image, map1.tileset[tonumber(map1.layer2Tile[i])], ((i-1)%map1.layer2Width)*map1.tileset1TileWidth, math.floor((i)/map1.layer2Width)*map1.tileset1TileHeight)
			elseif tonumber(map1.layer2Tile[i]) >= map1.tileset2FirstGid then
				love.graphics.draw(map1.tileset2Image, map1.tileset[tonumber(map1.layer2Tile[i])], ((i-1)%map1.layer2Width)*map1.tileset2TileWidth, math.floor((i)/map1.layer2Width)*map1.tileset2TileHeight)
			end
		end
	end
end